package configuration;

import java.sql.Connection;

import sqltools.InsertBuffer;

import utility.PropertyUtility;
import mysqltools.MySqlInsertBuffer;
import mysqltools.MySqlTools;

public class Configuration {

	public final static String DB_HOST = "127.0.0.1";
	public final static String DB_NAME = "intern09";
	public final static String DB_USER = "root";
	public final static String DB_PWD = "var123var";
	
	private String dbHost;
	private String dbName;
	private String dbUser;
	private String dbPwd;
	
	public static InsertBuffer getInsertBuffer() {
		return new MySqlInsertBuffer();
	}
	
	/**
	 * No instances of this class.
	 *
	 */
	public Configuration(String configfile) {
		// read parameters from CONFIG_FILE
		PropertyUtility.init(configfile, 
				"Configuration file '" + configfile + "' not found. Using default settings.\n"); 

		PropertyUtility prop = PropertyUtility.getInstance();
		if (prop == null) { System.out.println("prop is NULL"); }
		dbHost = prop.getProperty("host", DB_HOST);
		dbName = prop.getProperty("db", DB_NAME);
		dbUser = prop.getProperty("user", DB_USER);
		dbPwd = prop.getProperty("pwd", DB_PWD);
	}

	public static void loadDrivers() throws Exception {
		// MYSQL specific setup of test environment
		MySqlTools.loadDriver();
	}

	public Connection getConnection() throws Exception {
		// MYSQL specific setup of test environment
		return MySqlTools.getConnection(dbHost, dbName, dbUser, dbPwd);
	}
	
	public static Connection[] getCons(int n) throws Exception {
		// connect to database
		MySqlTools.loadDriver();
		System.err.println("Connecting to database...(intern09@127.0.0.1)");
		
		Connection[] res = new Connection[n];
		for (int i = 0; i < n; i++) {
			res[i] = MySqlTools.getConnection("127.0.0.1", "intern09",
					 "root", "var123var");
		}
		return res;
	}
	
	
	public Connection[] getConnections(int num) throws Exception {
		Connection[] cons = new Connection[num];
		for (int i = 0; i < num; i++) {
			cons[i] = getConnection();
		}
		return cons;
	}

	public String getDbHost() {
		return dbHost;
	}

	public void setDbHost(String dbHost) {
		this.dbHost = dbHost;
	}

	public String getDbName() {
		return dbName;
	}

	public void setDbName(String dbName) {
		this.dbName = dbName;
	}

	public String getDbPwd() {
		return dbPwd;
	}

	public void setDbPwd(String dbPwd) {
		this.dbPwd = dbPwd;
	}

	public String getDbUser() {
		return dbUser;
	}

	public void setDbUser(String dbUser) {
		this.dbUser = dbUser;
	}
	
	
	
	
			
}
