package mainmemcorrect;

import index.EditOperation;
import index.Index;
import configuration.*;
import java.sql.*;
import java.util.ListIterator;
import java.io.*;



import mysqltools.MySqlInsertBuffer;
import adjacencyenc.AdjacencyEncForest;
import sqltools.*;

/**
 * @author Varunesh Mishra
 */
public class DoEditOpsOnTreem {
	
	
	
	private static int pvalue;
	private static int qvalue;
	private static Index idxx;
	public static String tablename;
	public DoEditOpsOnTreem(int pp,int qq,Index idxx,String tname)
	{
		DoEditOpsOnTreem.setPvalue(pp);
		DoEditOpsOnTreem.setQvalue(qq);
		DoEditOpsOnTreem.setIdxx(idxx);
		DoEditOpsOnTreem.set_t_name(tname);
	}
	
	public static void set_t_name(String tname) {
		// TODO Auto-generated method stub
		DoEditOpsOnTreem.tablename=tname;
		
	}
	
	public static String get_table_name()
	{
		return tablename;
	}
	

	
	
	
	
	public static int pval()
	{
		return getPvalue();
	}
	public static int qval()
	{
		return getQvalue();
	}
	public static Index getidx()
	{
		return getIdxx();
	}
	
	
	
	/**
	 * 
	 * @param args
	 * @throws Exception
	 */
	public static void main(String[] args) throws Exception {
		
		FileOutputStream out; // declare a file output object
        PrintStream p1; // declare a print stream object
		
		if (args.length != 4) {
			System.err.println("  Doing <n> edit ops on an existing pq-gram index for the forest in table <tblName>.");
			System.err.println("  params: tblName p q n");
			System.err.println("  Will change tree as well as index.");
			System.exit(-1);
		}
		String tblName = args[0];
		int p = Integer.parseInt(args[1]);
		int q = Integer.parseInt(args[2]);
		int n = Integer.parseInt(args[3]);
		
		try
		{
			
			
		// Create a new file output stream
        // connected to "myfile.txt"
       // out = new FileOutputStream("C:\\Intern09\\outputs\\editops.txt",true);
        // Connect print stream to the output stream
        //p1 = new PrintStream( out );
		
		// connect to database
		// connect to database
		Connection[] con = Configuration.getCons(2);
		
		AdjacencyEncForest f = new AdjacencyEncForest(con[0], con[1],
				new MySqlInsertBuffer(), tblName);
		
		SQLTools.DEBUG = false;
		
		String idxName = tblName + "_Idx_" + p + q;
		//Index idx = new Index(idxName, con[0], p, q, new hash.StringHash(4));
		Index idx = new Index(idxName, con[0], p, q, new hash.PrefixHash(2));
		new DoEditOpsOnTreem(p,q,idx,idxName);
		
		System.out.println("# Doing " + n + " edit operations on " + p + "," + q + "-gram index `"
				+ idxName + "` for `" + tblName + "`...");
		//p1.println("# Doing " + n + " edit operations on " + p + "," + q + "-gram index `"
			//	+ idxName + "` for `" + tblName + "`...");
		System.out.println("# treeID, treeSize [nodes], time [ms], #editOps");
		//p1.println("# treeID, treeSize [nodes], time [ms], #editOps");		
		
		String qry =
			"SELECT " + f.getAtbTreeID() + ", COUNT(" + f.getAtbNodeID() + ") AS cnt FROM `" 
			+ f.getTblName() + "` GROUP BY " + f.getAtbTreeID();
		ResultSet trees = SQLTools.executeQuery(f.getStatement(), qry,
				"Selecting treeIDs from " + f.getTblName() + ".");
		while (trees.next()) {
			int treeID =  trees.getInt(f.getAtbTreeID());
			int size = trees.getInt("cnt");
			f.setWriteLog(true);
			TreeUpdateSeqm.editSequence(f, treeID, n);
			long start = System.currentTimeMillis();
			idx.update(f);
			System.out.println(treeID + " " + size + " " + (System.currentTimeMillis() - start) + " " + n);
			System.out.println("Here starts the reverse operation");
			/*
			 * Doing the operations in Reverse Direction
			 */
			
			
		//	p1.println(treeID + " " + size + " " + (System.currentTimeMillis() - start) + " " + n);
		}
		}
		catch(Exception e)
		{
			System.out.println("Error occured - check the code");
			e.printStackTrace();
		}			
	}
	
	public static void setQvalue(int qvalue) {
		DoEditOpsOnTreem.qvalue = qvalue;
	}


	public static int getQvalue() {
		return qvalue;
	}


	public static void setPvalue(int pvalue) {
		DoEditOpsOnTreem.pvalue = pvalue;
	}


	public static int getPvalue() {
		return pvalue;
	}


	public static void setIdxx(Index idxx) {
		DoEditOpsOnTreem.idxx = idxx;
	}


	public static Index getIdxx() {
		return idxx;
	}
	
}
