package tools;
import intervalenc.IntervalEncForest;

import java.util.Iterator;

import tree.LblValTree;
import configuration.*;
/*
 * Created on Feb 1, 2005
 */

/**
 * Given a forest and a depth, all treeIDs of trees with given depth are
 * printed to std-out.
 * 
 * @author augsten
 */
public class ConvertForestTblToFile {
	
	public static final String MSG_USAGE 
		= "params: tblName (= table in interval encoding) \n";

	public static void main(String[] args) throws Exception {
		int argcnt = 1;
		if (args.length != argcnt) {
			System.err.println(MSG_USAGE);
		} else {
			Configuration config = new Configuration("." + ConvertForestTblToFile.class.getSimpleName());
			Configuration.loadDrivers();
			
			// initialize forests
			String tblName = args[0];
			IntervalEncForest tblForest = new IntervalEncForest(config.getConnection(), 
					config.getConnection(), 
					Configuration.getInsertBuffer(), tblName);
				

			for (Iterator<LblValTree> it = tblForest.forestIterator(); it.hasNext();) {
				LblValTree t = it.next();
				System.out.println(t);
			}
		}
	}
}
