/**
 * 
 */
package tools;

import intervalenc.IntervalEncForest;

import java.sql.Connection;

import buildingblocks.ForestTools;

import sqltools.SQLTools;
import configuration.*;
/**
 * @author naugsten
 *
 */
public class CopySubForest {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		if (args.length < 4) {
			System.out.println("\nparams: sourceForest targetForest numTrees minTreeSize [maxTreeSize]");
			System.out.println("\n  Copy numTrees trees from sourceForest to targetForest "
					+ "\n  where the copied trees have at least minTreeSize nodes and" 
					+ "\n  at most maxTreeSize nodes (if given)." 
					+ "\n  The table targetForest is reset before the copy operation.\n");
			System.exit(-1);
		}
		SQLTools.DEBUG = false;
		Configuration config = new Configuration("." + SplitForest.class.getSimpleName());
		config.loadDrivers();
		Connection[] con = config.getConnections(4);		
		
		IntervalEncForest source = new IntervalEncForest(con[0], con[1], config.getInsertBuffer(), args[0]);
		IntervalEncForest target = new IntervalEncForest(con[2], con[3], config.getInsertBuffer(), args[1]);
		target.reset();
		int numTrees = Integer.parseInt(args[2]);
		int minTreeSize = Integer.parseInt(args[3]);
		int maxTreeSize = Integer.MAX_VALUE;
		if (args.length == 5) { 
			maxTreeSize = Integer.parseInt(args[4]);
		}
		int num = ForestTools.copySubForst(source, target, numTrees, minTreeSize, maxTreeSize);
		System.out.println("Copied " + num + " trees from '" + 
				source.getTblName() + "' to '" + target.getTblName() + "'");

	}

}
