package tools;
import java.io.IOException;
import tree.MMForest;
import tree.LblTree;

/*
 * Created on Feb 1, 2005
 */

/**
 * Given a forest and a depth, all treeIDs of trees with given depth are
 * printed to std-out.
 * 
 * @author augsten
 */
public class GetForestFileInfo {
	
	public static final String MSG_USAGE 
		= "params: forestfile depth\n";

	public static void main(String[] args) throws IOException {
		int argcnt = 2;
		if (args.length != argcnt) {
			System.err.println(MSG_USAGE);
		} else {
			String filename = args[0];
			int d = Integer.parseInt(args[1]);
			MMForest f = new MMForest(filename);
			
			// find all with depth 1
			int d1 = 0;
			for (int i = 0; i < f.size(); i++) {
				LblTree t = f.getTreeAt(i);
				if (t.getDepth() == d) {
					d1++;
					System.out.print(t.getTreeID() + ",");
				}
			}
			System.out.println("\n" + d1 + " trees have depth " + d);
		}
	}
}
