package tools;

import java.io.FileNotFoundException;
import java.io.IOException;

import utility.PropertyUtility;

public class GetProperty {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws IOException {
		if (args.length != 2) {
			System.err.println("\nparams config-file name\n");
			System.err.println("The config-file stores pairs 'name=value'.");
			System.err.println("For a given name the program writes the value to std-out (no white spaces!).\n");
			System.exit(-1);
		}
		String configFile = args[0];
		String propertyName = args[1];
		
		try {
			PropertyUtility.init(configFile); 

		PropertyUtility prop = PropertyUtility.getInstance();
		String value = prop.getProperty(propertyName);
		if (value != null) {
			System.out.print(value);
		} else {
			System.err.println("Property name '" + propertyName + "' not found in '" + configFile + "'.");
		} 
		} catch (FileNotFoundException e) {
			System.err.println("Configuration file '" + configFile + "' not found.");
		} 
	}

}
