package tools;

import java.io.FileOutputStream;
import java.io.PrintStream;
import java.sql.Connection;
import tree.*;

import adjacencyenc.*;
import configuration.*;

public class LoadTree {
	
	
	public static void load_tree(String args[]) throws Exception
	{
		Configuration config = new Configuration("." + LoadXMLForest.class.getSimpleName());
		config.loadDrivers();
		if (args.length < 3) {
			LoadXMLForest.writeErrMsg();
		}
		
		String tblName = args[0];
		String encoding = args[1];
		
		// connect to database
		Connection[] con = config.getConnections(2);
		AdjacencyEncForest f = new AdjacencyEncForest(con[0], con[1],
				config.getInsertBuffer(), tblName);
		f.reset();
		LblTree t1=LblTree.fromString(args[2]);
		LblValTree t=new LblValTree(t1);
		f.storeTree(t);
	}
	
	public static void writeErrMsg() {
		System.err.println("\nparams: table_name adj StringTree_n\n");
		System.err.println("  adj    ... adjacency list encoding with (id,label) nodes");
	//	System.err.println("  ie    ... interval encoding with (id,label,value) nodes");
	//	System.err.println("  ieLbl   ... interval encoding with (id, label) nodes");
	//	System.err.println("  file_i ... XML file, will get ID=i in the table\n");
	//	System.err.println("NOTE:\n  For large XML documents you might have to set a larger value\n  for the entity expantion limit, e.g.,");
		System.err.println("\n  java -DentityExpansionLimit=20000000 LoadXMLForest ...\n");
		System.exit(-1);
	}
	
	public static void main(String[] args) throws Exception {
		
		Configuration config = new Configuration("." + LoadXMLForest.class.getSimpleName());
		config.loadDrivers();
		if (args.length < 3) {
			LoadXMLForest.writeErrMsg();
		}
		
		String tblName = args[0];
		String encoding = args[1];
		
		// connect to database
		Connection[] con = config.getConnections(2);
		AdjacencyEncForest f = new AdjacencyEncForest(con[0], con[1],
				config.getInsertBuffer(), tblName);
		f.reset();
		LblTree t1=LblTree.fromString(args[2]);
		LblValTree t=new LblValTree(t1);
		f.storeTree(t);
		
	
	}
}
