package tools;

import java.util.Enumeration;

import tree.LblTree;

public class PSTree {
	
	public static String blanks(int n) {
		StringBuffer sb = new StringBuffer();
		for (int i = 0; i < n; i++) {
			sb.append(" ");
		}
		return sb.toString();
	}
	
	public static StringBuffer pstree(LblTree t, StringBuffer pst, int level) {
		int b = 2; 
		if (t.isLeaf()) {
			pst.append(blanks(level * b) + "\\Tr{" + t.getLabel() + "}\n");
		} else {
			pst.append(blanks(level * b) + "\\pstree{\\Tr{" + t.getLabel() + "}}{\n");
			for (Enumeration e = t.children(); e.hasMoreElements();) {
				pst = pstree((LblTree)e.nextElement(), pst, level + 1);
			}
			pst.append(blanks(level * b) + "}\n");
		}
		return pst;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		if (args.length != 1) {
			System.out.println("\nparams: tree");
			System.out.println("  print pstree-representation (for latex) of the input tree");
			System.out.println();
			System.out.println("Trees are given as strings with braces, e.g. {a{b}{c}} is\n");
			LblTree.fromString("{a{b}{c}}").prettyPrint();
			System.exit(-1);
			
		}
		LblTree t = LblTree.fromString(args[0]);
		//t.prettyPrint();
		System.out.println(pstree(t, new StringBuffer(), 0));

	}

}
