package tools;

import intervalenc.Cursor;
import intervalenc.IntervalEncForest;
import intervalenc.IntervalEncNode;

import java.sql.Connection;
import java.sql.SQLException;

import mysqltools.MySqlTools;

import tree.LblTree;
import tree.LblValTree;
import configuration.*;
/*
 * Created on 22-Apr-06
 */


public class ShowTblTree {
	
	public ShowTblTree() {
		super();
	}
	


	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		if (args.length != 3) {
			System.out.println("\nparams tblName [screen|latex] treeID\n\nPrints a tree from an interval-encoded table.\n");
			System.exit(-1);
		}
		String tblName = args[0];
		int treeID = Integer.parseInt(args[2]);
		
		Configuration config = new Configuration("." + ShowTblTree.class.getSimpleName());
		config.loadDrivers();
		Connection con = config.getConnection();
		IntervalEncForest f = new IntervalEncForest(con, tblName);
		LblValTree t2 = f.loadTree(treeID);
		if (t2 == null) {
			System.out.println("Tree does not exist.");
		} else {
			if (args[1].equals("latex")) {
				System.out.println(t2.toLatex());
			} else {				
				t2.prettyPrint();
			}
		}
	}	

}
