package tools;
/*
 * Created on Feb 21, 2005
 */

import tree.MMForest; 
import tree.LblTree;

/**
 * Simple class that gets a text file with trees as an input,
 * scans it and outputs the tree with the ID given in the command line.
 * 
 * @author augsten
 */
public final class ShowTree {
	
	public static final String PARAMS = "params: filename treeID\n"
		+ "  filename ... file with trees represented as treeID:{root{nd{...}}...{...}}}";
	
	private ShowTree() {		
	}

	public static void main(String[] args) throws Exception {
		if (args.length != 2) {
			System.out.println(PARAMS);
		} else {
			String filename = args[0];
			int treeID = Integer.parseInt(args[1]);
			MMForest f = new MMForest(filename);
			LblTree n = f.getTree(treeID);
			if (n == null) {
				System.out.println("No tree with ID " + 
						treeID + " in in file '" + filename + "'");
			} else {
				n.prettyPrint();
				System.out.println(n);
			}
		}
	}
}
