/**
 * 
 */
package tools;

import java.io.FileOutputStream;
import java.io.PrintStream;

import tree.LblTree;
import tree.LblValTree;

/**
 * @author Varunesh
 *
 */
public class TreeDistance {

	/**
	 * @param args
	 */
	public static double tree_dis(String args[],String fname)
	{
		double dist, normDist,d=0.0;
		String msgParams = 
			"usage 1: tree1 tree2 ed       --> compute ordered edit distance \n" +
			"usage 2: tree1 tree2 pqg p q  --> compute pq-gram distance\n";
		if (args.length <= 2) {			
			System.out.println(msgParams);
			System.exit(-1);
		} 
		System.out.println("tree1 "+args[0].length());
		System.out.println("tree2 "+args[1].length());
		LblValTree t1 = LblValTree.fromString(args[0]);
		LblValTree t2 = LblValTree.fromString(args[1]);
		
		distance.TreeDist distFunc = null;
		
		FileOutputStream out; // declare a file output object
        PrintStream ps; // declare a print stream object

        try
        {
                // Create a new file output stream
                // connected to "myfile.txt"
                out = new FileOutputStream(fname,true);

                // Connect print stream to the output stream
                ps = new PrintStream( out );

               
		
		if ((args.length == 3) && (args[2].equals("ed"))) {
			distFunc = new distance.EditDist(false);
		} else if ((args.length == 5) && (args[2].equals("pqg"))) {
			if (args[2].equals("pqg")) {
				System.out.println("Insidee pqg");
				int p = Integer.parseInt(args[3]);
				int q = Integer.parseInt(args[4]);
				ps.print(""+p+" "+q);
				distFunc = new distance.PQGramDist(p, q, false);
			} else {
				System.out.println("Sorry. Not implemented.");
				System.exit(-1);
			}
		}
		 d = distFunc.treeDist(t1, t2);
		System.out.println("d=" + d);
		ps.print(" "+d);
		
		 ps.println ();
		 ps.close();
		
        }
         catch (Exception e)
		{
         System.err.println ("Error writing to file");
		}
		return d;
	}
	
	
	public static void main(String[] args) {
		double dist, normDist;
		String msgParams = 
			"usage 1: tree1 tree2 ed       --> compute ordered edit distance \n" +
			"usage 2: tree1 tree2 pqg p q  --> compute pq-gram distance\n";
		if (args.length <= 2) {			
			System.out.println(msgParams);
			System.exit(-1);
		} 
		LblValTree t1 = LblValTree.fromString(args[0]);
		LblValTree t2 = LblValTree.fromString(args[1]);
		distance.TreeDist distFunc = null;
		if ((args.length == 3) && (args[2].equals("ed"))) {
			distFunc = new distance.EditDist(false);
		} else if ((args.length == 5) && (args[2].equals("pqg"))) {
			if (args[2].equals("pqg")) {
				System.out.println("Insidee pqg");
				int p = Integer.parseInt(args[3]);
				int q = Integer.parseInt(args[4]);
				distFunc = new distance.PQGramDist(p, q, false);
			} else {
				System.out.println("Sorry. Not implemented.");
				System.exit(-1);
			}
		}
		double d = distFunc.treeDist(t1, t2);
		System.out.println("d=" + d);
	}

}
