/*
 * Created on Sep 30, 2005
 */
package vldb2006;

import index.Index;

import java.sql.*;
import java.io.*;

import mysqltools.MySqlInsertBuffer;
import adjacencyenc.AdjacencyEncForest;
import sqltools.*;
import configuration.*;
import configuration.Configuration;
/**
 * @author augsten
 */
public class DoEditOpsOnTree {
	
	/**
	 * 
	 * @param args
	 * @throws Exception
	 */
	public void do_edit_ops(String args[])
	{
		FileOutputStream out; // declare a file output object
        
		
		if (args.length != 4) {
			System.err.println("  Doing <n> edit ops on an existing pq-gram index for the forest in table <tblName>.");
			System.err.println("  params: tblName p q n");
			System.err.println("  Will change tree as well as index.");
			System.exit(-1);
		}
		String tblName = args[0];
		int p = Integer.parseInt(args[1]);
		int q = Integer.parseInt(args[2]);
		int n = Integer.parseInt(args[3]);
		
		try
		{
			
			
		// Create a new file output stream
        // connected to "myfile.txt"
        out = new FileOutputStream("C:\\Intern09\\outputs\\editops.txt",true);
        // Connect print stream to the output stream
       
		
		// connect to database
		// connect to database
		Connection[] con = Configuration.getCons(2);
		
		AdjacencyEncForest f = new AdjacencyEncForest(con[0], con[1],
				new MySqlInsertBuffer(), tblName);
		
		SQLTools.DEBUG = false;
		
		String idxName = tblName + "_Idx_" + p + q;
		Index idx = new Index(idxName, con[0], p, q, new hash.StringHash(4));
		//Index idx = new Index(idxName, con[0], p, q, new hash.PrefixHash(2));
		
		System.out.println("# Doing " + n + " edit operations on " + p + "," + q + "-gram index `"
				+ idxName + "` for `" + tblName + "`...");
		
		System.out.println("# treeID, treeSize [nodes], time [ms], #editOps");
		
		String qry =
			"SELECT " + f.getAtbTreeID() + ", COUNT(" + f.getAtbNodeID() + ") AS cnt FROM `" 
			+ f.getTblName() + "` GROUP BY " + f.getAtbTreeID();
		ResultSet trees = SQLTools.executeQuery(f.getStatement(), qry,
				"Selecting treeIDs from " + f.getTblName() + ".");
		while (trees.next()) {
			int treeID =  trees.getInt(f.getAtbTreeID());
			int size = trees.getInt("cnt");
			f.setWriteLog(true);
			TreeUpdateSeq.editSequence(f, treeID, n);
			long start = System.currentTimeMillis();
			//idx.update(f);
			System.out.println(treeID + " " + size + " " + (System.currentTimeMillis() - start) + " " + n);
			
		}
		}
		catch(Exception e)
		{
			System.out.println("Error occured - check the code");
			e.printStackTrace();
		}			
	}
	
	public static void main(String[] args) throws Exception {
		
		FileOutputStream out; // declare a file output object
        PrintStream p1; // declare a print stream object
		
		if (args.length != 4) {
			System.err.println("  Doing <n> edit ops on an existing pq-gram index for the forest in table <tblName>.");
			System.err.println("  params: tblName p q n");
			System.err.println("  Will change tree as well as index.");
			System.exit(-1);
		}
		String tblName = args[0];
		int p = Integer.parseInt(args[1]);
		int q = Integer.parseInt(args[2]);
		int n = Integer.parseInt(args[3]);
		
		try
		{
			
			
		// Create a new file output stream
        // connected to "myfile.txt"
        out = new FileOutputStream("C:\\Intern09\\outputs\\editops.txt",true);
        // Connect print stream to the output stream
        p1 = new PrintStream( out );
		
		// connect to database
		// connect to database
		Connection[] con = Configuration.getCons(2);
		
		AdjacencyEncForest f = new AdjacencyEncForest(con[0], con[1],
				new MySqlInsertBuffer(), tblName);
		
		SQLTools.DEBUG = false;
		
		String idxName = tblName + "_Idx_" + p + q;
		//Index idx = new Index(idxName, con[0], p, q, new hash.StringHash(4));
		Index idx = new Index(idxName, con[0], p, q, new hash.PrefixHash(2));
		
		System.out.println("# Doing " + n + " edit operations on " + p + "," + q + "-gram index `"
				+ idxName + "` for `" + tblName + "`...");
		p1.println("# Doing " + n + " edit operations on " + p + "," + q + "-gram index `"
				+ idxName + "` for `" + tblName + "`...");
		System.out.println("# treeID, treeSize [nodes], time [ms], #editOps");
		p1.println("# treeID, treeSize [nodes], time [ms], #editOps");		
		
		String qry =
			"SELECT " + f.getAtbTreeID() + ", COUNT(" + f.getAtbNodeID() + ") AS cnt FROM `" 
			+ f.getTblName() + "` GROUP BY " + f.getAtbTreeID();
		ResultSet trees = SQLTools.executeQuery(f.getStatement(), qry,
				"Selecting treeIDs from " + f.getTblName() + ".");
		while (trees.next()) {
			int treeID =  trees.getInt(f.getAtbTreeID());
			int size = trees.getInt("cnt");
			f.setWriteLog(true);
			TreeUpdateSeq.editSequence(f, treeID, n);
			long start = System.currentTimeMillis();
			idx.update(f);
			System.out.println(treeID + " " + size + " " + (System.currentTimeMillis() - start) + " " + n);
			p1.println(treeID + " " + size + " " + (System.currentTimeMillis() - start) + " " + n);
		}
		}
		catch(Exception e)
		{
			System.out.println("Error occured - check the code");
			e.printStackTrace();
		}			
	}
}
