package indexing;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.Random;
import tree.LblTree;
import tree.LblValTree;

import random.RandomVal;

import distance.Profile;

class Query
{
	
	int prf_ind;
	double range;
	
}

class N_Profile
{
	LinkedList refL = new LinkedList();
}

class refer_D
{

	double d[];
	public refer_D(int n)
	{
		d = new double[n];
	}
}

public class Assign_references {
	public LinkedList Query_List = new LinkedList();
	public LinkedList N_Profile_List = new LinkedList();
	public double d[][];
	public double dq[][];
	public int p_val;
	public int q_val;
	public static int dsk_io;
	public static int dsk_io_e;
	
	public Assign_references(int p,int q)
	{
		this.p_val = p;
		this.q_val = q;
	}
	public void generate_query(int n,LinkedList Profile_List)
	{
		RandomVal rand = new RandomVal();
		Random rnd = new Random();
		int sz = Profile_List.size();
		for(int i=0;i<n;i++)
		{
			Query obj = new Query();
			
				/*
				 * Range_Query
				 */
				
				obj.prf_ind = rand.getInt(0,sz-1);
				obj.range = rnd.nextDouble();
				Query_List.add(obj);
		}
	}
	
	public boolean prune(int s,int r,Query qu,int q_ind,Profile p1,Profile p2)
	{
		boolean isprune = false;
		double dvs = d[r][s];
		double dvq = dq[r][q_ind];
		double lb = 0;
		double up = 0;
		distance.TreeDist distFunc = null;
		distFunc = new distance.PQGramDist(p_val, q_val, false);
		double sq = distFunc.profile_dis(p1, p2);
		/*
		 * check if the upper limit and lower limit of distance
		 */
		lb = Math.abs(dvs - dvq);
		up = dvs + dvq;
		if (qu.range >= lb && qu.range <= up)
			return false;
		else 
			return true;
		
	}
	
	
	
	public void assign_Dis(LinkedList r,LinkedList p)
	{
		int r1 = r.size();
		int p1 = p.size();
		d = new double[r1][p1];
		System.out.println("r1 "+r1+" p1 "+p1);
		r1 = 0;
		p1 = 0;
		
		distance.TreeDist distFunc = null;
		distFunc = new distance.PQGramDist(p_val, q_val, false);
		for(Iterator it = r.iterator(); it.hasNext();) {
			Profile p_temp = (Profile)it.next();
			for(Iterator jt = p.iterator(); jt.hasNext();) {
				Profile s_temp = (Profile)jt.next();
				d[r1][p1] = distFunc.profile_dis(p_temp, s_temp);
				System.out.print(d[r1][p1]+" "+p_temp.size()+" "+s_temp.size()+" ");
				p1++;
				}
			System.out.println();
			p1 = 0;
			r1++;
		}
	}
	
	public void assign_Disq(LinkedList r,LinkedList p)
	{
		int r1 = r.size();
		int q1 = Query_List.size();
		dq = new double[r1][q1];
		q1 = 0;
		r1 = 0;
		distance.TreeDist distFunc = null;
		distFunc = new distance.PQGramDist(p_val, q_val, false);
		for(Iterator it = r.iterator(); it.hasNext();) {
			Profile p_temp = (Profile)it.next();
			for(Iterator jt = Query_List.iterator(); jt.hasNext();) {
				Query s_temp = (Query)jt.next();
				Profile pr = (Profile) p.get(s_temp.prf_ind);
				dq[r1][q1] = distFunc.profile_dis(p_temp, pr);
				System.out.print(dq[r1][q1]+" ");
				q1++;
				}
			System.out.println();
			q1 = 0;
			r1++;
		}
	}
	
	
	public int max_val(int a[])
	{
		int arg = 0;
		int temp = a[arg];
		
		for(int i=0;i<a.length;i++)
		{
			if (a[i] > temp)
			{
				temp = a[i];
				arg = i;
			}
		}
		return arg;
	}
	
	public void assignment(LinkedList Prof,LinkedList ref,int k)
	{
		int gain[] = new int[ref.size()];
		int vcount[] = new int[ref.size()];
		int rnd=0;
		for(;rnd < Prof.size();rnd++)
		{
			Profile temp = (Profile) Prof.get(rnd);
			N_Profile nprof = new N_Profile();
			LinkedList QList_clone = (LinkedList) Query_List.clone();
			LinkedList ref_clone = (LinkedList)ref.clone();
			while(nprof.refL.size()< k)
			{
				//int i = 0;
				for(int i=0;i<ref_clone.size();i++)
				{
					vcount[i] = 0;
					for(int j=0;j<QList_clone.size();j++){
						Query q_tmp = (Query)QList_clone.get(j);
						if(prune(rnd,i,q_tmp,Query_List.indexOf(q_tmp),temp,(Profile)Prof.get(q_tmp.prf_ind)))
						{
							vcount[i]++;
							QList_clone.remove(j);
							
						}
					}
			/*
			 * Finding Maximum Argument
			 */
				
				int e = max_val(vcount);
				nprof.refL.addLast(e);
				System.out.println("nprof size "+nprof.refL.size()+" e "+e);
				gain[e]= gain[e] + vcount[e];
				vcount[e] = -100000;
				ref_clone.remove(e);
				
				
			}
		}
			System.out.println("varun");
		N_Profile_List.addLast(nprof);
	}
		
		int qs = Query_List.size();
		System.out.println("qs "+qs);
		
		for(int i=0;i<ref.size();i++)
		{
			if(gain[i]<qs)
			{
				ref.remove(i);
			}
		}
		
		update(ref,Prof,N_Profile_List);
		
		
		//update the set;
		
	}
	
	
	public void update(LinkedList ref,LinkedList Prof,LinkedList nprof)
	{
		for(int i=0;i<Prof.size();i++)
		{
			N_Profile temp = new N_Profile();
			temp = (N_Profile) nprof.get(i);
			for(Iterator it = temp.refL.iterator(); it.hasNext();) {
				Profile t = (Profile)Prof.get((Integer) it.next());
				if(ref.contains(t))
				{
					
				}
				else
				{
					temp.refL.remove(t);
				}
			}
		}
	}
	
	public void range_search(Query q,LinkedList ref,LinkedList Prof)
	{
		int ind = q.prf_ind;
		double r = q.range;
		int disk_io = 0;
		int dsk_io_w = 0;
		System.out.println("ind "+ind);
		Profile q_temp = (Profile)Prof.get(ind);
		distance.TreeDist distFunc = null;
		distFunc = new distance.PQGramDist(p_val, q_val, false);
		double d_q[] = new double[ref.size()];
		int i = 0;
		for(Iterator it = ref.iterator(); it.hasNext();) 
		{
			Profile s_temp = (Profile)it.next();
			d_q[i]= distFunc.profile_dis(q_temp, s_temp);
			System.out.println("dq "+d_q[i]);
			i++;
		}
			q.range = 50.0;
			i = 0;
			for(Iterator it = N_Profile_List.iterator(); it.hasNext();) 
			{
				dsk_io_e++;
				N_Profile temp = (N_Profile)it.next();
				for(Iterator jt = temp.refL.iterator(); jt.hasNext();) 
				{
					
					int pos = (Integer)jt.next();
					//System.out.println("position "+pos);
					double upr = d[pos][i] +  d_q[pos];
					double low = Math.abs(d[pos][i] - d_q[pos]);
					System.out.println("pos "+pos);
					if(q.range > low && q.range < upr)
					{
						/*
						 * Explicitly check the distance between them
						 */
						Profile prf = (Profile)Prof.get(i);
						Profile q_prf = (Profile)Prof.get(q.prf_ind);
						distFunc = new distance.PQGramDist(p_val, q_val, false);
						double d = distFunc.profile_dis(prf, q_prf);
						dsk_io++;
						if(d < q.range)
						{
							
							System.out.println("WITH DISK I/O The profile "+i+" distance is "+d+" lwr "+low +" upr "+upr);
							break;
						}
						else
						{
							System.out.println("WITH DISK I/O The profile "+i+" is not in output distance "+d+" upr "+upr+" lwr "+ low);
							break;
						}
						
						
					}
					else if(q.range > upr)
					{
						/*
						 * It is definitely in the output
						 */
						System.out.println("The profile "+i+" is in Output upr "+upr);
					}
					else
					{
						System.out.println("The profile "+i+" is not in output");
						/*
						 * No need to check,
						 */
					}
					
					
				}
				i++;
				
				
				
			}
			
			
			System.out.println("Total Disk I/O are "+disk_io);
			System.out.println("Total DIsk I/O expected withut index structure "+dsk_io_w);
			System.out.println("Selectivity is "+(1-(double)disk_io/(double)dsk_io_w));
			
			
		
		
		
		
		
		
		
		
		
		
	}
	

}
