package indexing;

import java.util.LinkedList;
import java.util.Random;

import random.RandomVal;
import tree.LblValTree;


import cs618_project_code.Tree_Generate;
import distance.PQGramDist;
import distance.Profile;

public class Generate_Data{
	public int pval;
	public int qval;
	public LinkedList Profs = new LinkedList();
	public LinkedList Qry = new LinkedList();
	public Generate_Data(int p,int q)
	{
		this.pval = p;
		this.qval = q;
	}
	public void generate_database(int n,int len,int no_label,boolean normalized)
	{
		Tree_Generate.set_labels(len, no_label);
		PQGramDist pq_grm = new PQGramDist(pval,qval,normalized);
		for(int i=0;i<n;i++)
		{
			Tree_Generate.nd = Tree_Generate.tree_database(100);
			String str = Tree_Generate.tree_label(Tree_Generate.nd);
			LblValTree t1 = LblValTree.fromString(str);
			Profile pr = pq_grm.getProfile(t1);
			Profs.addLast(pr);
		}
	}
	
	public void generate_query(int n)
	{
		RandomVal rand = new RandomVal();
		Random rnd = new Random();
		int sz = Profs.size();
		for(int i=0;i<n;i++)
		{
			Query temp = new Query();
			temp.prf_ind = rand.getInt(0,sz-1);
			temp.range = rnd.nextDouble();
			Qry.addLast(temp);
		}
	}
	
	public static void main(String args[])
	{
		Generate_Data obj = new Generate_Data(3,3);
		obj.generate_database(5, 2, 10, false);
		for(int i =0 ;i<obj.Profs.size();i++)
		{
			Profile temp = (Profile)obj.Profs.get(i);
			int i1 = 0;
			System.out.println(" i th "+i);
			while(i1 < temp.size())
			{
				System.out.print(temp.elementAt(i1));
				i1++;
			}
			System.out.println();
		}
		obj.generate_query(10);
		for(int i=0;i<obj.Qry.size();i++)
		{
			Query temp = new Query();
			temp =(Query)obj.Qry.get(i);
			System.out.println("i "+i+" range "+temp.range+" profile "+temp.prf_ind);
		}
	}
	

}
