/*
 * Created on Jul 10, 2008
 */
package distance;

import java.io.BufferedReader;
import java.io.File;
import java.io.InputStream;
import java.io.InputStreamReader;
import util.FileIO;

/**
 * @author naugsten
 */
public class CrossParsing implements StringDist {

	public static String tmpFile1 = "text1";
	public static String tmpFile2 = "text2";
	public static String cmdName = "./crossparse " + tmpFile1 + " " + tmpFile2;

	public static double crossparse(String s1, String s2) {
		double dist = -1;		
		if ((s1.length() == 0) && (s2.length() == 0)) {
			return 0;
		} 
		if (s1.length() == 0) {
			return 0.5;
		}
		if (s2.length() == 0) {
			return 0.5;
		}		
		try {
			File f1 = new File(tmpFile1);
			if (!f1.exists()) {
				f1.createNewFile();
			}
			File f2 = new File(tmpFile2);
			if (!f2.exists()) {
				f2.createNewFile();
			}
			FileIO.setContents(f1, s1);
			FileIO.setContents(f2, s2);
			Runtime rt = Runtime.getRuntime();
			Process p = rt.exec(cmdName);
			InputStream in = p.getInputStream();
			// OutputStream out = p.getOutputStream();
			//InputStream err = p.getErrorStream();

		     BufferedReader input =
		         new BufferedReader
		           (new InputStreamReader(p.getInputStream()));
		     String distStr = input.readLine();
			dist = Double.parseDouble(distStr);

			p.destroy() ;
		} catch (Exception e) {
			System.err.println("Crossparse writes the temporaray files '" + tmpFile1 + 
					"' and '" + tmpFile2 + "'\nand calls the external programm '" + cmdName + "'");
			System.err.println("There where the following problems doing this:");
			e.printStackTrace();
		}
		return dist;
	}

	public static double crossparse(char[] tokens1, char[] tokens2) {
		StringBuffer sb1 = new StringBuffer();
		StringBuffer sb2 = new StringBuffer();
		for (int i = 0; i < tokens1.length; i++) {
			sb1.append(tokens1[i] + "\n");
		}
		for (int i = 0; i < tokens2.length; i++) {
			sb2.append(tokens2[i] + "\n");
		}
		return crossparse(sb1.toString(), sb2.toString());
	}

	public static double crossparse(String[] tokens1, String[] tokens2) {
		return 0;
	}

	/**
	 * @see distance.StringDist#normStringDist(java.lang.String, java.lang.String)
	 */
	public double normStringDist(String s1, String s2) {
		return crossparse(s1.toCharArray(), s2.toCharArray());
	}

	/**
	 * @see distance.StringDist#stringDist(java.lang.String, java.lang.String)
	 */
	public double stringDist(String s1, String s2) {
		return Math.round(normStringDist(s1, s2) * (s1.length() + s2.length()));
	}

}
