package distance;
import tree.LblTree;

public class NodeData {
	String label;
	int height;
	int outdegree;
	int children;
	int compactGraph;
	int preorder;
	
	NodeData(LblTree n, int preorder) {
		label = n.getLabel();
		height = n.getDepth();
		outdegree = n.getChildCount();
		children = outdegree;
		this.preorder = preorder;
		compactGraph = -1;
	}
	
	public void setPreorder(int preorder) {
		this.preorder = preorder;
	}
	
	public int getPreorder() {
		return preorder;
	}
	
	public int getCompactGraph() {
		return compactGraph;
	}
	
	public void setCompactGraph(int compactGraph) {
		this.compactGraph = compactGraph;
	}
	
	public void decreaseChildren() {
		children--;
	}
	
	public boolean hasZeroChildren() {
		return (children == 0);
	}
	
	public boolean equals(NodeData nd) {
		return (label.equals(nd.label) && 
				(height == nd.height) &&
				(outdegree == nd.outdegree));
	}
	
	@Override
	public String toString() {
		return "{'" + label + "', h: " + height + " out: " + outdegree + 
		" ch: " + children + ", pre: " + preorder + "}";
	}
}

