/*
 * Created on Mar 4, 2008
 */
package distance;

public class WeightedPQGram extends PQGram {
	
	double weight;
	
	public WeightedPQGram(String[] pNodes, String[] qNodes, double weight) {
		super(pNodes, qNodes);
		this.weight = weight;
	}

	@Override
	public int compareTo(Object o) {
		int cmp = super.compareTo(o);
		if (cmp == 0) {
			double diff = weight - ((WeightedPQGram)o).weight;
			if (diff > 0) {
				return 1;
			} else if (diff < 0) {
				return -1;
			} else {
				return 0; 
			}
		} else {
			return cmp;
		}
	}
	
	public int unweightedCompareTo(PQGram g) {
		return super.compareTo(g);
	}

	public double getWeight() {
		return weight;
	}

	public void setWeight(double weight) {
		this.weight = weight;
	}

	@Override
	public String toString() {
		return "<" + super.toString() + "," + this.getWeight() + ">";
	}
	
	
	
}
