package marriage;

public class Relation {
  public Association list;

  public Relation() {
    list = new Association(null, null, null);
  }

  Association find(Object target) {
    // return Assocation _before_ target in list
    Association cur = list;
    while ((cur.next != null) && (cur.next.domain != target)) {
		cur = cur.next;
	}
    return cur;
  }

  public void map(Object d, Object r) {
    Association oneBefore = find(d);
    if (oneBefore.next == null) {
		// didn't find it, so append new item to list end
		  oneBefore.next = new Association(d, r, null);
	} else {
		// did find it, so replace range
		  oneBefore.next.range = r;
	}
  }

  public Object drop(Object d) {
    Association oneBefore = find(d);
    // make sure not at end of list (if it wasn't found, no need to drop)
    Object result;
    if (oneBefore.next != null) {
      result = oneBefore.next.range;
      oneBefore.next = oneBefore.next.next;
      return result;
    } else {
		return null;
	}
  }

  public Object lookup(Object d) {
    Association oneBefore = find(d);
    if (oneBefore.next == null) {
		// didn't find it, return null
		  return null;
	} else {
		return oneBefore.next.range;
	}
  }

  @Override
public String toString() {
    String result = "(";
    Association cur = list;
    while (cur.next != null) {
       result = result + cur.next;
       cur = cur.next;
    }
    return result + ")";
  }
} 




