package random;
public class RandomBoolean extends RandomVal {

    double trueProbability;

    public RandomBoolean(double trueProbability, long seed) {
	super(UNIFORM, seed); 
	this.trueProbability = trueProbability;
    }

    public RandomBoolean(double trueProbability) {
	this(trueProbability, System.currentTimeMillis());
    }


    public boolean getBoolean() {
	return super.getBoolean(trueProbability);
    }

    @Override
	public String toString() {
	String res = trueProbability * 100 + "% true";
	return res;
    }

    public double getTrueProbability() {
	return trueProbability;
    }

    public static void main(String[] args) {
	double p = Double.parseDouble(args[0]);
	RandomBoolean rb = new RandomBoolean(p);
	System.out.println(rb);
	int tests = 1000000;
	int cnt = 0;
	for (int i = 0; i < tests; i++) {
	    if (rb.getBoolean()) {
		cnt++;
	    }
	}
	System.out.println("p=" + cnt + " = " +
			   (double)cnt / (double)tests * 100 + "%");
    }
}
