/**
 * 
 */
package util;

import java.util.Iterator;
import java.util.NoSuchElementException;

/**
 * In addition to {@link java.util.Iterator} a fetch operation is implemented. It is used to
 * look at the current element in the iterator.
 *   
 * @author naugsten
 */
public interface FetchIterator<T> extends Iterator<T> {

	/**
	 * Returns the element at the current iterator position, i.e., it returns the
	 * same element that the previous call of next() has returned. 
	 * If next has never been called, an exception is thrown. 
	 * 
	 * @return element at current iterator position 
	 * @throws NoSuchElementException there was no previous call of next()
	 */
	public T fetch() throws NoSuchElementException;
	
}
